/* ***********************************************************
 * This file was automatically generated on 2016-06-30.      *
 *                                                           *
 * Visual Basic .NET Bindings Version 2.1.9                  *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Creates 1kHz beep
	/// </summary>
	public class BrickletPiezoBuzzer : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 214;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Piezo Buzzer Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_BEEP = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_MORSE_CODE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_BEEP_FINISHED = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_MORSE_CODE_FINISHED = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;



		/// <summary>
		///  This callback is triggered if a beep set by <see cref="Tinkerforge.BrickletPiezoBuzzer.Beep"/> is finished
		/// </summary>
		public event BeepFinishedEventHandler BeepFinished;
		/// <summary>
		/// </summary>
		public delegate void BeepFinishedEventHandler(BrickletPiezoBuzzer sender);

		/// <summary>
		///  This callback is triggered if the playback of the morse code set by
		///  <see cref="Tinkerforge.BrickletPiezoBuzzer.MorseCode"/> is finished.
		/// </summary>
		public event MorseCodeFinishedEventHandler MorseCodeFinished;
		/// <summary>
		/// </summary>
		public delegate void MorseCodeFinishedEventHandler(BrickletPiezoBuzzer sender);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletPiezoBuzzer(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 0;
			callbackWrappers[CALLBACK_BEEP_FINISHED] = new CallbackWrapper(OnBeepFinished);
			callbackWrappers[CALLBACK_MORSE_CODE_FINISHED] = new CallbackWrapper(OnMorseCodeFinished);

			responseExpected[FUNCTION_BEEP] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_MORSE_CODE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_BEEP_FINISHED] = ResponseExpectedFlag.ALWAYS_FALSE;
			responseExpected[CALLBACK_MORSE_CODE_FINISHED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Beeps with the duration in ms. For example: If you set a value of 1000,
		///  the piezo buzzer will beep for one second.
		/// </summary>
		public void Beep(long duration)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_BEEP);
			LEConverter.To((int)duration, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Sets morse code that will be played by the piezo buzzer. The morse code
		///  is given as a string consisting of "." (dot), "-" (minus) and " " (space)
		///  for *dits*, *dahs* and *pauses*. Every other character is ignored.
		///  
		///  For example: If you set the string "...---...", the piezo buzzer will beep
		///  nine times with the durations "short short short long long long short 
		///  short short".
		///  
		///  The maximum string size is 60.
		/// </summary>
		public void MorseCode(string morse)
		{
			byte[] request = CreateRequestPacket(68, FUNCTION_MORSE_CODE);
			LEConverter.To((string)morse, 8, 60, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnBeepFinished(byte[] response)
		{
			var handler = BeepFinished;
			if(handler != null)
			{
				handler(this);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnMorseCodeFinished(byte[] response)
		{
			var handler = MorseCodeFinished;
			if(handler != null)
			{
				handler(this);
			}
		}
	}
}
